<!-- Generated by documentation.js. Update this documentation by updating the source code. -->

## AbstractFactory

Base class for factory builders

### getBuilder

A factory can return a builder to customize building of its 
  child nodes.

**Parameters**

-   `parent`  

Returns **[object](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object)** An optional builder for child nodes.

### isLeaf

returns true if no child closures should be processed

Returns **[boolean](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Boolean)** true if no child closures should be processed

### newInstance

Creates a new instance identified by type `name` and provided `args`.

**Parameters**

-   `the` **builder** builder.
-   `the` **[name](https://developer.mozilla.org/en-US/)** name of the node being built.
-   `the` **args** args to pass to the constructor.
-   `builder`  
-   `name`  
-   `args`  

Returns **[object](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object)** the newly constructed object.

### setChild

Called by the builder to establish a parent-to-child relationship.

**Parameters**

-   `the` **builder** builder.
-   `the` **[parent](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/Input)** parent node
-   `the` **child** child node
-   `builder`  
-   `parent`  
-   `child`  

Returns **any** none

### setParent

Called by the builder to establish a child-to-parent relationship.

**Parameters**

-   `the` **builder** builder.
-   `the` **[parent](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/Input)** parent node
-   `the` **child** child node
-   `builder`  
-   `parent`  
-   `child`  

Returns **any** none

### onNodeCompleted

Called by the builder to notify when a node is built.

**Parameters**

-   `the` **builder** builder.
-   `the` **[parent](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/Input)** parent node
-   `the` **child** child node
-   `builder`  
-   `parent`  
-   `node`  

Returns **any** none

## FactoryBuilderSupport

**Extends EventEmitter**

A groovy-builder like object-tree builder for developing 
JavaScript DSLs.

### registerFactory

Register a factory for a node name

**Parameters**

-   `the` **[name](https://developer.mozilla.org/en-US/)** node name.
-   `the` **factory** factory associated with name.
-   `name`  
-   `factory`  

### build

Execute given closure to build nodes with this builder.

**Parameters**

-   `the` **closure** closure to execute
-   `closure`  

Returns **[object](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object)** the top level node built by the builder.

### buildFile

`require` given file to build nodes with this builder.

**Parameters**

-   `file` **file** to require
-   `args` **...any** 

Returns **[object](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object)** the top level node built by the builder.
